#include "BsonConverter.h"

#include <bsoncxx/builder/stream/array.hpp>
#include <bsoncxx/builder/stream/document.hpp>
#include <bsoncxx/builder/stream/helpers.hpp>
#include <bsoncxx/json.hpp>

namespace armarx::armem::server::ltm::processor::converter::data::object
{
    namespace bsoncxxbuilder = bsoncxx::builder::stream;
    namespace bsoncxxdoc = bsoncxx::document;

    BsonConverter::ConversionResult
    BsonConverter::_convert(const aron::data::DictPtr& data)
    {
        auto [jsonVec, str] = jsonConverter.convert(data);
        std::string json(jsonVec.begin(), jsonVec.end());
        auto view = bsoncxx::from_json(json).view();

        std::vector<unsigned char> bson(view.length());
        if (view.length() > 0)
        {
            std::memcpy(bson.data(), view.data(), view.length());
        }
        return {bson, str};
    }

    aron::data::DictPtr
    BsonConverter::_convert(const ConversionResult& data, const armarx::aron::Path& p)
    {
        bsoncxx::document::view view(data.data.data(), data.data.size());
        nlohmann::json json = bsoncxx::to_json(view);
        std::string str = json.dump();

        ConversionResult j;
        j.data = std::vector<unsigned char>(str.begin(), str.end());
        j.suffix = data.suffix;

        auto v = jsonConverter.convert(j, p);
        return aron::data::Dict::DynamicCast(v);
    }
} // namespace armarx::armem::server::ltm::processor::converter::data::object
