#pragma once

#include <RobotAPI/libraries/skills/core/SkillProxy.h>

namespace armarx
{
    namespace skills
    {
        template <class AronT>
        class SpecializedSkillProxy : public SkillProxy
        {
        public:
            using SkillProxy::SkillProxy;

            // Provide a similar API as the skillprovider
            TerminatedSkillStatusUpdate
            executeSkill(const std::string& executorName, const AronT& params)
            {
                return SkillProxy::executeSkill(executorName, params.toAron());
            }

            SkillExecutionID
            executeSkillAsync(const std::string& executorName, const AronT& params = nullptr)
            {
                return SkillProxy::executeSkillAsync(executorName, params.toAron());
            }

            // Utiliy methods
            AronT
            getRootProfileParameters()
            {
                auto dict = SkillProxy::getRootProfileParameters();
                if (dict)
                {
                    return AronT::FromAron(dict);
                }
                return {};
            }
        };
    } // namespace skills
} // namespace armarx
